/*
 * J2meMob.java
 *
 * Created on April 10, 2005, 3:30 PM
 */

//Imports
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;

import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.StringItem;
import javax.microedition.lcdui.TextField;
import javax.microedition.midlet.MIDlet;
import javax.microedition.rms.RecordStore;
import javax.microedition.rms.RecordStoreNotFoundException;

public class J2meMob extends MIDlet implements CommandListener, Runnable {

	private Thread syncThread;

	private Display display = Display.getDisplay(this);

	private final static String url = "http://localhost:8080/syncwebapp/SyncServlet";

	Form mainForm = new Form("J2MEMobApp");

	Form searchForm;
	
	Form syncForm;

	// Command Button
	private Command searchOrderButton = new Command("Search Order", Command.OK,
			1);

	private Command searchResultsButton = new Command("Search Results",
			Command.OK, 1);

	private Command insertOrderButton = new Command("Insert New Order",
			Command.OK, 1);

	private Command addOrderButton = new Command("Add Order", Command.OK, 1);

	private Command backButton;

	private Command exitButton = new Command("Exit Application", Command.OK, 2);

	private Command syncStartButton = new Command("Start Syncronization",
			Command.OK, 1);

	private Command syncButton = new Command("Synronize Order", Command.OK, 1);

	// Constants
	private static final String RECORD_ADDED = "N";

	private static final String ORDER_SHIPPED = "N";

	// UI Text Fields
	TextField searchField = new TextField("Search By Order Id", "", 25,
			TextField.ANY);

	TextField userId = new TextField("User Id", "", 10, TextField.ANY);

	TextField customerId = new TextField("Customer Id", "", 10, TextField.ANY);

	TextField productName = new TextField("Product Name", "", 40, TextField.ANY);

	TextField orderQty = new TextField("Product Qty", "", 2, TextField.NUMERIC);

	TextField orderStatus = new TextField("Order Status", "", 2, TextField.ANY);

	TextField orderId = new TextField("Order Id", "", 25, TextField.ANY);

	StringItem errorMessage = new StringItem("", "");

	// Record Store
	RecordStore recStore;

	private static final Command okCmd = new Command("OK", Command.OK, 1);

	public J2meMob() {

		mainForm.addCommand(insertOrderButton);
		mainForm.addCommand(searchOrderButton);
		mainForm.addCommand(exitButton);
		mainForm.append(errorMessage);
		mainForm.setCommandListener(this);
		display.setCurrent(mainForm);
	}

	private void createDatabase() {
		connect();

	}

	private void connect() {
		try {

			try {
				recStore = RecordStore.openRecordStore("OrderDB", false);
			} catch (RecordStoreNotFoundException re) {

			}

			if (recStore == null) {
				// Create New one
				recStore = RecordStore.openRecordStore("OrderDB", true);

			}

		} catch (Exception e) {

			System.out.println("Error " + e);
			errorMessage.setLabel("Error:");
			errorMessage.setText(e.toString());
		}

	}

	public void startApp() {
		// Create Database
		createDatabase();

	}

	public void pauseApp() {

	}

	public void destroyApp(boolean unconditional) {
		closeConnection();

	}

	public void commandAction(Command c, Displayable d) {
		try {

			if (c == exitButton) {
				destroyApp(false);
				notifyDestroyed();
				return;
			} else if (c == backButton) {
				display.setCurrent(mainForm);
				mainForm.setCommandListener(this);
				return;
			}

			else if (c == searchOrderButton) {
				searchForm = new Form("Track Order By Order Id");
				searchForm.append(searchField);

				searchForm.addCommand(searchResultsButton);
				searchForm.addCommand(syncButton);
				searchForm.addCommand(exitButton);
				searchForm.setCommandListener(this);
				display.setCurrent(searchForm);

			}

			if (c == syncButton) {
				syncForm = new Form("Syncronize");
				System.out.println("userid" + userId.getString().length());
				if (userId.getString() != null
						&& userId.getString().length() > 0) {

					
					
					performSyncronization();
					
					
					
				} else {
					syncForm.append("Enter userid for syncronization");
					syncForm.append(userId);
				

				}
					syncForm.addCommand(syncButton);
					syncForm.addCommand(searchOrderButton);
					syncForm.addCommand(exitButton);
					syncForm.setCommandListener(this);
					display.setCurrent(syncForm);

			}

			else if (c == searchResultsButton) {

				Form searchResultsForm = new Form("Order Tracking Results");

				Vector results = fetchData(searchField.getString());
				if (results != null && results.size() > 0) {
					orderId.setString((String) results.elementAt(0));
					userId.setString((String) results.elementAt(1));
					customerId.setString((String) results.elementAt(2));

					productName.setString((String) results.elementAt(3));
					orderQty.setString((String) results.elementAt(4));
					orderStatus.setString((String) results.elementAt(5));

					searchResultsForm.append(userId);
					searchResultsForm.append("\n");
					searchResultsForm.append(customerId);
					searchResultsForm.append("\n");
					searchResultsForm.append(productName);
					searchResultsForm.append("\n");
					searchResultsForm.append(orderQty);
					searchResultsForm.append("\n");
					searchResultsForm.append(orderStatus);
					searchResultsForm.append("\n");
				} else {
					searchResultsForm.append("No Results Found");
				}
				display.setCurrent(searchResultsForm);

			}

			else if (c == insertOrderButton) {

				Form insertOrderForm = new Form("Insert Order");

				insertOrderForm.addCommand(exitButton);
				insertOrderForm.addCommand(addOrderButton);
				insertOrderForm.addCommand(syncButton);
				insertOrderForm.setCommandListener(this);

				insertOrderForm.append(userId);
				insertOrderForm.append(customerId);
				insertOrderForm.append(productName);
				insertOrderForm.append(orderQty);

				display.setCurrent(insertOrderForm);

			}

			else if (c == addOrderButton) {

				Form orderIdForm = new Form("Order Information");

				String orderId = insertRecord();

				orderIdForm
						.append("Your order has been inserted, the order is  "
								+ orderId);

				orderIdForm.addCommand(searchOrderButton);

				orderIdForm.addCommand(exitButton);

				orderIdForm.addCommand(syncButton);

				orderIdForm.setCommandListener(this);

				display.setCurrent(orderIdForm);

			}

		} catch (Exception e) {

			System.out.println("Error " + e);

			errorMessage.setLabel("Error:");
			errorMessage.setText(e.toString());

		}
	}

	private Vector fetchData(String orderId) {
		Vector records = new Vector();
		try {

			ByteArrayInputStream stream;
			DataInputStream reader;

			String orderID;

			for (int i = 1; i <= recStore.getNumRecords()
					&& records.size() == 0; i++) {
				byte[] rec = new byte[recStore.getRecordSize(i)];

				rec = recStore.getRecord(i);

				stream = new ByteArrayInputStream(rec);
				reader = new DataInputStream(stream);
				orderID = reader.readUTF();

				if (orderID.equals(orderId)) {

					records.addElement(orderID);
					// User Id
					records.addElement(reader.readUTF());
					// Customer Id
					records.addElement(reader.readUTF());
					// Product Name
					records.addElement(reader.readUTF());
					// Productquantity
					records.addElement(reader.readUTF());
					// Order status
					records.addElement(reader.readUTF());
					// sync status
					records.addElement(reader.readUTF());
					// order create date
					records.addElement(reader.readUTF());
					// record id
					records.addElement(new Integer(i));
				}
			}

		} catch (Exception e) {
			errorMessage.setLabel("Error:");
			errorMessage.setText(e.toString());
		}

		return records;
	}

	private Vector fetchDataToSyncronize() {
		Vector records = new Vector();
		try {

			ByteArrayInputStream stream;
			DataInputStream reader;

			String orderID;

			for (int i = 1; i <= recStore.getNumRecords()
					&& records.size() == 0; i++) {
				byte[] rec = new byte[recStore.getRecordSize(i)];
				rec = recStore.getRecord(i);
				stream = new ByteArrayInputStream(rec);
				reader = new DataInputStream(stream);
				OrderBean orderBean = new OrderBean();

				orderBean.setOrderId(reader.readUTF());
				// User Id
				orderBean.setUserId(reader.readUTF());
				// Customer Id
				orderBean.setCustomerId(reader.readUTF());
				// Product Name
				orderBean.setProductName(reader.readUTF());
				// Productquantity
				orderBean.setProductQuantity(reader.readUTF());
				// Order status
				orderBean.setOrderStatus(reader.readUTF());
				// sync status
				orderBean.setSyncStatus(reader.readUTF());
				// order create date
				orderBean.setOrderDate(String.valueOf(reader.readLong()));

				if (orderBean.getSyncStatus().equals("N")) {
					records.addElement(orderBean);
				}

			}

		} catch (Exception e) {
			errorMessage.setLabel("Error:");
			errorMessage.setText(e.toString());
		}

		return records;
	}

	private void closeConnection() {
		try {
			if (recStore != null) {
				recStore.closeRecordStore();

			}
		} catch (Exception e) {
			System.out.println("Error " + e);

			errorMessage.setLabel("Error:");
			errorMessage.setText(e.toString());
		}
	}

	private String insertRecord() {
		String orderId = null;
		try {
			int recordID = 0;
			ByteArrayOutputStream bytstream = new ByteArrayOutputStream();
			DataOutputStream writer = new DataOutputStream(bytstream);

			long timeStamp = System.currentTimeMillis();

			// Generate Unique Key.
			orderId = userId.getString() + String.valueOf(timeStamp);

			writer.writeUTF(orderId);
			writer.writeUTF(userId.getString());
			writer.writeUTF(customerId.getString());
			writer.writeUTF(productName.getString());
			writer.writeUTF(orderQty.getString());
			writer.writeUTF(ORDER_SHIPPED);
			writer.writeUTF(RECORD_ADDED);
			writer.writeLong(timeStamp);
			writer.flush();

			byte[] rec = bytstream.toByteArray();
			recordID = recStore.addRecord(rec, 0, rec.length);
			System.out.println("recordID" + recordID);

			System.out.println("orderId" + orderId);
			writer.close();
			bytstream.close();

		} catch (Exception e) {
			System.out.println("Error " + e);

			errorMessage.setLabel("Error:");
			errorMessage.setText(e.toString());
		}
		return orderId;

	}

	public static void main(String[] argv) {
		new J2meMob().startApp();
	}

	/*
	 * This method starts the synronization thread
	 */

	private void performSyncronization() {

		syncThread = new Thread(this);
		syncThread.start();
		return;
	}

	/*
	 * This method performs syncronization process.
	 */
	public void run() {

		try {
			syncronize();

			System.out.println("Synchronization succeeded ");

		} catch (Exception e) {
			System.out.println("syncronization failed" + e.getMessage());
		}

	}

	/*
	 * Synronizes the data
	 */
	private void syncronize() throws Exception {

		ByteArrayOutputStream bStrm = null;
		HttpConnection hc = null;
		int ch;
		OutputStream output = null;
		InputStream iStrm = null;
		String outPutData = null;

		try {

			// formulates which data needs to be syncronized
			// rule applicable is data which is of status "N" only needs to be
			// syncronized and sent to server.
			Vector vect = fetchDataToSyncronize();

			String xmlData = formulateXML(vect);

			// Http Call.

			hc = (HttpConnection) Connector.open(url);

			hc.setRequestMethod(HttpConnection.POST);

			// If you experience connection/IO problems, try
			// removing the comment from the following line
			// http.setRequestProperty("Connection", "close");

			output = hc.openOutputStream();
			output.write(xmlData.getBytes());
			output.flush();

			iStrm = hc.openInputStream();
			int length = (int) hc.getLength();

			bStrm = new ByteArrayOutputStream();
			while ((ch = iStrm.read()) != -1) {
				// Ignore any carriage returns/linefeeds
				if (ch != 10 && ch != 13)
					bStrm.write(ch);
			}

			System.out.println(new String(bStrm.toByteArray()));
			outPutData = new String(bStrm.toByteArray());
		} finally {
			if (iStrm != null) {
				iStrm.close();
			}
			if (output != null) {
				output.close();
			}
			if (hc != null) {
				hc.close();
			}

		}

		if (outPutData != null && outPutData.indexOf("failed") != -1) {
			throw new Exception(outPutData);
		} else {
			updateSyncronizeData(outPutData);
		}

	}

	private String formulateXML(Vector vect) {
		StringBuffer sb = new StringBuffer();

		int len = vect.size();
		sb.append("<sync-data>");
		sb.append("<userid>");
		sb.append(userId.getString());
		sb.append("</userid>");

		if (len > 0) {

			for (int k = 0; k < len; k++) {

				OrderBean orderBean = (OrderBean) vect.elementAt(k);
				sb.append("<record>");

				sb.append("<id>");
				sb.append(orderBean.getOrderId());
				sb.append("</id>");

				sb.append("<orderdate>");
				sb.append(orderBean.getOrderDate());
				sb.append("</orderdate>");

				sb.append("<userid>");
				sb.append(orderBean.getUserId());
				sb.append("</userid>");

				sb.append("<customerid>");
				sb.append(orderBean.getCustomerId());
				sb.append("</customerid>");

				sb.append("<productname>");
				sb.append(orderBean.getProductName());
				sb.append("</productname>");

				sb.append("<productquantity>");
				sb.append(orderBean.getProductQuantity());
				sb.append("</productquantity>");

				sb.append("<orderstatus>");
				sb.append(orderBean.getOrderStatus());
				sb.append("</orderstatus>");

				sb.append("<syncstaus>");
				sb.append(orderBean.getSyncStatus());
				sb.append("</syncstaus>");

				sb.append("</record>");
			}
		}
		sb.append("</sync-data>");

		return sb.toString();

	}

	private void updateSyncronizeData(String outputXml) throws Exception {

		// Extract Order Id.

		// For each record , get order id and update data

		Vector vectOrderBean = convertXMLtoBean(outputXml);
		String orderId = null;

		if (vectOrderBean != null && vectOrderBean.size() > 0) {
			int asize = vectOrderBean.size();
			for (int vsize = 0; vsize < asize; vsize++) {
				OrderBean orderBean = (OrderBean) vectOrderBean
						.elementAt(vsize);
				Vector vect = fetchData(orderBean.getOrderId());

				// Get Record Id;
				Integer recordId = (Integer) vect.elementAt(8);
				updateData(orderBean, recordId.intValue());
			}
		}

	}

	private void updateData(OrderBean orderBean, int recorId) throws Exception {

		ByteArrayOutputStream bytstream = null;
		DataOutputStream writer = null;
		try {
			bytstream = new ByteArrayOutputStream();
			writer = new DataOutputStream(bytstream);

			writer.writeUTF(orderBean.getOrderId());
			writer.writeUTF(orderBean.getUserId());
			writer.writeUTF(orderBean.getCustomerId());
			writer.writeUTF(orderBean.getProductName());
			writer.writeUTF(orderBean.getProductQuantity());
			writer.writeUTF(orderBean.getOrderStatus());
			writer.writeUTF(orderBean.getSyncStatus());
			writer.writeLong(Long.parseLong(orderBean.getOrderDate()));
			writer.flush();

			byte[] rec = bytstream.toByteArray();
			recStore.setRecord(recorId, rec, 0, rec.length);
			System.out.println("recordID" + recorId);

			System.out.println("orderId" + orderId);

		} finally {
			if (writer != null) {
				writer.close();

			}
			if (bytstream != null) {
				bytstream.close();
			}

		}

	}

	private Vector convertXMLtoBean(String outPutData) throws Exception {
		SyncParser syncPraser = new SyncParser();
		Vector vect = syncPraser.parse(outPutData);
		return vect;

	}

}
