package sync.smartapp;

import java.io.*;
import java.util.Vector;
import org.kxml.*;
import org.kxml.parser.*;

public class SyncParser {

	/**
	 * @param outputXML
	 * @return
	 * @throws Exception
	 */
	public Vector parse(String outputXML) throws Exception {
		Vector vect = new Vector();

		Reader reader = new StringReader(outputXML);
		XmlParser parser = new XmlParser(reader);
		ParseEvent pe = null;
		boolean parse = true;

		parser.skip();
		parser.read(Xml.START_TAG, null, "sync-data");
		parser.skip();
		String userid = null;
		parser.read(Xml.START_TAG, null, "userid");
		pe = parser.read();

		// Add the userid as first element
		userid = pe.getText();
		vect.addElement(userid);

		while (parse) {
			pe = parser.read();
			if (pe.getType() == Xml.START_TAG) {
				String name = pe.getName();
				if (name.equals("record")) {
					OrderBean orderBean = new OrderBean();
					String id;
					String fieldname;

					while ((pe.getType() != Xml.END_TAG)
							|| (pe.getName().equals(name) == false)) {
						pe = parser.read();
						if (pe.getType() == Xml.START_TAG
								&& pe.getName().equals("id")) {
							pe = parser.read();
							orderBean.setOrderId(pe.getText());
						} else if (pe.getType() == Xml.START_TAG
								&& pe.getName().equals("orderdate")) {
							pe = parser.read();
							orderBean.setOrderDate(pe.getText());
						} else if (pe.getType() == Xml.START_TAG
								&& pe.getName().equals("userid")) {
							pe = parser.read();
							orderBean.setUserId(pe.getText());
						} else if (pe.getType() == Xml.START_TAG
								&& pe.getName().equals("customerid")) {
							pe = parser.read();
							orderBean.setCustomerId(pe.getText());
						} else if (pe.getType() == Xml.START_TAG
								&& pe.getName().equals("productname")) {
							pe = parser.read();
							orderBean.setProductName(pe.getText());
						} else if (pe.getType() == Xml.START_TAG
								&& pe.getName().equals("productquantity")) {
							pe = parser.read();
							orderBean.setProductQuantity(pe.getText());
						} else if (pe.getType() == Xml.START_TAG
								&& pe.getName().equals("orderstatus")) {
							pe = parser.read();
							orderBean.setOrderStatus(pe.getText());
						} else if (pe.getType() == Xml.START_TAG
								&& pe.getName().equals("syncstaus")) {
							pe = parser.read();
							orderBean.setSyncStatus(pe.getText());
						}

					}
					vect.addElement(orderBean);
				} else {
					while ((pe.getType() != Xml.END_TAG)
							|| (pe.getName().equals(name) == false))
						pe = parser.read();
				}
			}
			if (pe.getType() == Xml.END_TAG && pe.getName().equals("sync-data"))
				parse = false;
		}

		return vect;

	}

}
